package com.its.op.service.its.rse;

import com.its.op.dao.repository.its.rse.TbRseCtrlHsRepository;
import com.its.op.dto.its.rse.TbRseCtrlHsDto;
import com.its.op.entity.its.rse.TbRseCtrlHs;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbRseCtrlHsService {

    private final TbRseCtrlHsRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbRseCtrlHs requireOne(Long id) throws NoSuchElementException {
        Optional<TbRseCtrlHs> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return this.repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbRseCtrlHsDto> findAll() {
        List<TbRseCtrlHsDto> result = new ArrayList<>();
        List<TbRseCtrlHs> data = this.repo.findAll();
        for (TbRseCtrlHs entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbRseCtrlHsDto findById(Long id) {
        TbRseCtrlHs entity = requireOne(id);
        return entity.toDto();
    }

}
